#pragma once

#include <entt/entt.hpp>
#include <components.h>

class SceneManager {
public:
    SceneManager(entt::registry& registry) : registry(registry), activeScene(entt::null) {}

    void SetActiveScene(entt::entity scene) {
        if (activeScene != entt::null) {
            auto& currentScene = registry.get<SceneComponent>(activeScene);
            currentScene.isActive = false;
        }

        activeScene = scene;
        auto& newScene = registry.get<SceneComponent>(activeScene);
        newScene.isActive = true;
    }

    entt::entity CreateScene() {
        entt::entity scene = registry.create();
        registry.emplace<SceneComponent>(scene, false);
        return scene;
    }

    void UpdateActiveScene() {
        if (activeScene != entt::null) {
        }
    }

    void RenderActiveScene() {
        if (activeScene != entt::null) {
        }
    }

private:
    entt::registry& registry;
    entt::entity activeScene;
};
